# Enum cargo::core::compiler::fingerprint::dirty_reason::DirtyReason

source ·

    pub enum DirtyReason {
    Show 23 variants    RustcChanged,
        FeaturesChanged {
            old: String,
            new: String,
        },
        TargetConfigurationChanged,
        PathToSourceChanged,
        ProfileConfigurationChanged,
        RustflagsChanged {
            old: Vec<String>,
            new: Vec<String>,
        },
        MetadataChanged,
        ConfigSettingsChanged,
        CompileKindChanged,
        LocalLengthsChanged,
        PrecalculatedComponentsChanged {
            old: String,
            new: String,
        },
        DepInfoOutputChanged {
            old: PathBuf,
            new: PathBuf,
        },
        RerunIfChangedOutputFileChanged {
            old: PathBuf,
            new: PathBuf,
        },
        RerunIfChangedOutputPathsChanged {
            old: Vec<PathBuf>,
            new: Vec<PathBuf>,
        },
        EnvVarsChanged {
            old: String,
            new: String,
        },
        EnvVarChanged {
            name: String,
            old_value: Option<String>,
            new_value: Option<String>,
        },
        LocalFingerprintTypeChanged {
            old: &'static str,
            new: &'static str,
        },
        NumberOfDependenciesChanged {
            old: usize,
            new: usize,
        },
        UnitDependencyNameChanged {
            old: InternedString,
            new: InternedString,
        },
        UnitDependencyInfoChanged {
            old_name: InternedString,
            old_fingerprint: u64,
            new_name: InternedString,
            new_fingerprint: u64,
        },
        FsStatusOutdated(FsStatus),
        NothingObvious,
        Forced,
    }

Expand description

Tells a better story of why a build is considered “dirty” that leads to a recompile. Usually constructed via `Fingerprint::compare`.

## Variants§

§

### RustcChanged

§

### FeaturesChanged

#### Fields

§`old: String`
§`new: String`
§

### TargetConfigurationChanged

§

### PathToSourceChanged

§

### ProfileConfigurationChanged

§

### RustflagsChanged

#### Fields

§`old: Vec<String>`
§`new: Vec<String>`
§

### MetadataChanged

§

### ConfigSettingsChanged

§

### CompileKindChanged

§

### LocalLengthsChanged

§

### PrecalculatedComponentsChanged

#### Fields

§`old: String`
§`new: String`
§

### DepInfoOutputChanged

#### Fields

§`old: PathBuf`
§`new: PathBuf`
§

### RerunIfChangedOutputFileChanged

#### Fields

§`old: PathBuf`
§`new: PathBuf`
§

### RerunIfChangedOutputPathsChanged

#### Fields

§`old: Vec<PathBuf>`
§`new: Vec<PathBuf>`
§

### EnvVarsChanged

#### Fields

§`old: String`
§`new: String`
§

### EnvVarChanged

#### Fields

§`name: String`
§`old_value: Option<String>`
§`new_value: Option<String>`
§

### LocalFingerprintTypeChanged

#### Fields

§`old: &'static str`
§`new: &'static str`
§

### NumberOfDependenciesChanged

#### Fields

§`old: usize`
§`new: usize`
§

### UnitDependencyNameChanged

#### Fields

§`old: InternedString`
§`new: InternedString`
§

### UnitDependencyInfoChanged

#### Fields

§`old_name: InternedString`
§`old_fingerprint: u64`
§`new_name: InternedString`
§`new_fingerprint: u64`
§

### FsStatusOutdated(FsStatus)

§

### NothingObvious

§

### Forced

## Implementations§

source§

### impl DirtyReason

source

#### fn after(old_time: FileTime, new_time: FileTime, what: &'static str) -> After

source

#### pub fn present_to( &self, s: &mut Shell, unit: &Unit, root: &Path ) -> CargoResult<()>

## Trait Implementations§

source§

### impl Clone for DirtyReason

source§

#### fn clone(&self) -> DirtyReason

Returns a copy of the value. Read more
1.0.0 · source§

#### fn clone_from(&mut self, source: &Self)

Performs copy-assignment from `source`. Read more
source§

### impl Debug for DirtyReason

source§

#### fn fmt(&self, f: &mut Formatter<'_>) -> Result

Formats the value using the given formatter. Read more

## Auto Trait Implementations§

§

### impl RefUnwindSafe for DirtyReason

§

### impl Send for DirtyReason

§

### impl Sync for DirtyReason

§

### impl Unpin for DirtyReason

§

### impl UnwindSafe for DirtyReason

## Blanket Implementations§

source§

### impl<T> Any for Twhere T: 'static + ?Sized,

source§

#### fn type_id(&self) -> TypeId

Gets the `TypeId` of `self`. Read more
source§

### impl<T> Borrow<T> for Twhere T: ?Sized,

const: unstable · source§

#### fn borrow(&self) -> &T

Immutably borrows from an owned value. Read more
source§

### impl<T> BorrowMut<T> for Twhere T: ?Sized,

const: unstable · source§

#### fn borrow_mut(&mut self) -> &mut T

Mutably borrows from an owned value. Read more
source§

### impl<T> From<T> for T

const: unstable · source§

#### fn from(t: T) -> T

Returns the argument unchanged.

source§

### impl<T, U> Into<U> for Twhere U: From<T>,

const: unstable · source§

#### fn into(self) -> U

Calls `U::from(self)`.

That is, this conversion is whatever the implementation of `From<T> for U` chooses to do.

source§

### impl<T> Same<T> for T

§

#### type Output = T

Should always be `Self`
source§

### impl<T> ToOwned for Twhere T: Clone,

§

#### type Owned = T

The resulting type after obtaining ownership.
source§

#### fn to_owned(&self) -> T

Creates owned data from borrowed data, usually by cloning. Read more
source§

#### fn clone_into(&self, target: &mut T)

Uses borrowed data to replace owned data, usually by cloning. Read more
source§

### impl<T, U> TryFrom<U> for Twhere U: Into<T>,

§

#### type Error = Infallible

The type returned in the event of a conversion error.
const: unstable · source§

#### fn try_from(value: U) -> Result<T, <T as TryFrom<U>>::Error>

Performs the conversion.
source§

### impl<T, U> TryInto<U> for Twhere U: TryFrom<T>,

§

#### type Error = <U as TryFrom<T>>::Error

The type returned in the event of a conversion error.
const: unstable · source§

#### fn try_into(self) -> Result<U, <U as TryFrom<T>>::Error>

Performs the conversion.
§

### impl<V, T> VZip<V> for Twhere V: MultiLane<T>,

§

#### fn vzip(self) -> V

## Layout§

Note: Most layout information is completely unstable and may even differ between compilations. The only exception is types with certain `repr(...)` attributes. Please see the Rust Reference’s “Type Layout” chapter for details on type layout guarantees.

Size: 88 bytes

Size for each variant:

- `RustcChanged`: 0 bytes
- `FeaturesChanged`: 56 bytes
- `TargetConfigurationChanged`: 0 bytes
- `PathToSourceChanged`: 0 bytes
- `ProfileConfigurationChanged`: 0 bytes
- `RustflagsChanged`: 56 bytes
- `MetadataChanged`: 0 bytes
- `ConfigSettingsChanged`: 0 bytes
- `CompileKindChanged`: 0 bytes
- `LocalLengthsChanged`: 0 bytes
- `PrecalculatedComponentsChanged`: 56 bytes
- `DepInfoOutputChanged`: 56 bytes
- `RerunIfChangedOutputFileChanged`: 56 bytes
- `RerunIfChangedOutputPathsChanged`: 56 bytes
- `EnvVarsChanged`: 56 bytes
- `EnvVarChanged`: 80 bytes
- `LocalFingerprintTypeChanged`: 40 bytes
- `NumberOfDependenciesChanged`: 24 bytes
- `UnitDependencyNameChanged`: 40 bytes
- `UnitDependencyInfoChanged`: 56 bytes
- `FsStatusOutdated`: 88 bytes
- `NothingObvious`: 0 bytes
- `Forced`: 0 bytes